unit SelectUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Buttons, CommonButton, ComCtrls, ExtCtrls, StdCtrls,
  ActnList, jpeg,
  FileList,
  ExePathUnit,
  IniFiles,
  MathUnit,
uses_end;

type
  TSelectForm = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Image1: TImage;
    UpDown1: TUpDown;
    CommonButton1: TCommonButton;
    PopupMenu1: TPopupMenu;
    D2007Menu: TMenuItem;
    D2006Menu: TMenuItem;
    D2005Menu: TMenuItem;
    D7Menu: TMenuItem;
    D6Menu: TMenuItem;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    FileList1: TFileList;
    ActionList1: TActionList;
    OKAct: TAction;
    procedure CommonButton1Click(Sender: TObject);
    procedure D2007MenuClick(Sender: TObject);
    procedure D2006MenuClick(Sender: TObject);
    procedure D2005MenuClick(Sender: TObject);
    procedure D7MenuClick(Sender: TObject);
    procedure D6MenuClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure OKActExecute(Sender: TObject);
    procedure OKActUpdate(Sender: TObject);
  private
    FSplashFileList: TStringList;
    FSplashIndex: Integer;
    procedure SetImage(PicturePath: String);
    procedure IniWrite;
    procedure IniRead;
  public
    { Public declarations }
  end;

var
  SelectForm: TSelectForm;

implementation

{$R *.dfm}


procedure TSelectForm.CommonButton1Click(Sender: TObject);
begin
  PopupMenu1.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TSelectForm.D2007MenuClick(Sender: TObject);
begin//
  Edit1.Text :=
    'C:\Program Files\CodeGear\RAD Studio\5.0\bin\bds.exe';
end;

procedure TSelectForm.D2006MenuClick(Sender: TObject);
begin//
  Edit1.Text :=
    'C:\Program Files\Borland\BDS\4.0\Bin\bds.exe';
end;


procedure TSelectForm.D2005MenuClick(Sender: TObject);
begin//
  Edit1.Text :=
    'C:\Program Files\Borland\BDS\3.0\Bin\bds.exe';
end;

procedure TSelectForm.D7MenuClick(Sender: TObject);
begin//
  Edit1.Text :=
    'C:\Program Files\Borland\Delphi7\Bin\delphi32.exe';
end;

procedure TSelectForm.D6MenuClick(Sender: TObject);
begin//
  Edit1.Text :=
    'C:\Program Files\Borland\Delphi6\Bin\delphi32.exe';
end;

procedure TSelectForm.FormCreate(Sender: TObject);
begin
  UpDown1.Max := High(SmallInt);
  UpDown1.Min := Low(SmallInt);

  FSplashFileList := TStringList.Create;

  FileList1.DestStrings := FSplashFileList;
  FileList1.Directory := AppFolderPath+PathDelim+'splash';
  FileList1.FileListType := flNormal;
  FileList1.List;

  FSplashIndex := -1;
  IniRead;
  if CheckRange(0, FSplashIndex ,FSplashFileList.Count) then
  begin
    SetImage(FSplashFileList.Strings[FSplashIndex]);
  end else
  begin
    FSplashIndex := -1;
  end;
end;

procedure TSelectForm.FormDestroy(Sender: TObject);
begin
  FSplashFileList.Free;
end;

procedure TSelectForm.SetImage(PicturePath: String);
begin
  Image1.Picture.LoadFromFile(PicturePath);

  Self.ClientWidth := Image1.Picture.Width;
  Self.ClientHeight := Image1.Picture.Height + Panel1.Height;

//  Image1.Constraints.MinHeight := Image1.Picture.Height;
//  Image1.Constraints.MinWidth := Image1.Picture.Width;
//  Image1.Constraints.MaxHeight := Image1.Picture.Height;
//  Image1.Constraints.MaxWidth := Image1.Picture.Width;
end;

procedure TSelectForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  case Button of
  btNext: begin
    Inc(FSplashIndex);
    if FSplashFileList.Count <= FSplashIndex then
    begin
      FSplashIndex := 0;
    end;
  end;
  btPrev: begin
    Dec(FSplashIndex);
    if FSplashIndex <= -1 then
    begin
      FSplashIndex := FSplashFileList.Count-1;
    end;
  end;
  end;

  SetImage(FSplashFileList.Strings[FSplashIndex]);
end;

procedure TSelectForm.IniRead;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(AppFolderPath+PathDelim+'DelphiSplashChanger.ini');
  with Ini do try
  Edit1.Text := ReadString('Delphi', 'FullPath', '');
  FSplashIndex :=
    FSplashFileList.IndexOf(
      FileList1.Directory+PathDelim+ReadString('Splash', 'FileName', ''));
  finally Ini.Free; end;
end;

procedure TSelectForm.IniWrite;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(AppFolderPath+PathDelim+'DelphiSplashChanger.ini');
  with Ini do try
  WriteString('Delphi', 'FullPath', Edit1.Text);
  WriteString('Splash', 'FileName',
    ExtractFileName(FSplashFileList[FSplashIndex]));
  finally Ini.UpdateFile; Ini.Free; end;
end;


procedure TSelectForm.OKActExecute(Sender: TObject);
begin
  IniWrite;
  Self.Close;
end;

procedure TSelectForm.OKActUpdate(Sender: TObject);
begin
  if FileExists(Edit1.Text) then
  begin
    TAction(Sender).Enabled := True;
  end else
  begin
    TAction(Sender).Enabled := False;
  end;
end;

procedure TSelectForm.BitBtn2Click(Sender: TObject);
begin
  Self.Close;
end;


end.
